unit udmdCustomer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ulibTrDBTables;

type
  TdmdCustomer = class(TDataModule)
    qryrCustomer: TrQuery;
    qryrCustomerCustNo: TFloatField;
    qryrCustomerCompany: TStringField;
    qryrCustomerAddr1: TStringField;
    qryrCustomerAddr2: TStringField;
    qryrCustomerCity: TStringField;
    qryrCustomerState: TStringField;
    qryrCustomerZip: TStringField;
    qryrCustomerCountry: TStringField;
    qryrCustomerPhone: TStringField;
    qryrCustomerFAX: TStringField;
    qryrCustomerTaxRate: TFloatField;
    qryrCustomerContact: TStringField;
    qryrCustomerLastInvoiceDate: TDateTimeField;
    sqryrCustomer: TDataSource;
    qryrCustomerFingerPrint: TStringField;
    updCustomer: TUpdateSQL;
    tblNextCust: TTable;
    tblNextCustNewCust: TFloatField;
    qrycboCustomerKey: TQuery;
    qrycboCustomerList: TQuery;
    qrycboCustomerKeyCustNo: TFloatField;
    qrycboCustomerKeyCompany: TStringField;
    qrycboCustomerKeyCity: TStringField;
    qrycboCustomerListCustNo: TFloatField;
    qrycboCustomerListCompany: TStringField;
    qrycboCustomerListCity: TStringField;
    procedure qryrCustomerCalcFields(DataSet: TDataSet);
    procedure qryrCustomerNewRecord(DataSet: TDataSet);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  dmdCustomer: TdmdCustomer;

implementation

{$R *.DFM}

procedure TdmdCustomer.qryrCustomerCalcFields(DataSet: TDataSet);
begin
  qryrCustomerFingerPrint.Text := '(null)';
end;

procedure TdmdCustomer.qryrCustomerNewRecord(DataSet: TDataSet);
Var retries: Integer;
    Index: Double;
begin
  retries := 0;
  While True do try
    tblNextCust.Close;
    tblNextCust.Exclusive := True;
    tblNextCust.Open;
    try
      tblNextCust.Edit;
      try
        Index := tblNextCustNewCust.AsFloat + 1;
        tblNextCustNewCust.AsFloat := Index;
        tblNextCust.Post;
        qryrCustomerCustNo.AsFloat := Index;
      except
        tblNextCust.Cancel;
        raise;
      end;
    finally
      tblNextCust.Close;
    end;
    break;
  except
    if retries > 5 then raise;
    Inc(retries);
    Sleep(100);
  end;
end;

end.
